#
# "awk" script to delete all comments from ml code.
# In a ml file all characters embedded by "%" characters
# are treated as comments, unless the "%" occurs within
# a string constant or a token constant or a character constant.

# modus:
#  0    nichts besonderes
#  1    innerhalb eines Strings "..."
#  2    innerhalb eines Zeichens '...'
#  3    ein Zeichen ` gelesen
#  4    innerhalb eines Tokens `...` oder `...'
#  5    innerhalb einer TokenList ``...``
#  6    innerhalb eines Kommentars
# backslash:
# Das letzte Zeichen war ein effektiver Backslash.

BEGIN {modus=0}
  { zeile=$0
    backslash=0
    dq=sprintf("%c",34)
    out=""
    suppress=0
    for (i=1; i <= length; i++) {
      c=substr(zeile,i,1)
      if (modus==0)
      {
 	if (c==dq) modus=1
	else if (c=="'") modus=2
	else if (c=="`") modus=3
        else if (c=="%") modus=6;
	backslash=0
      } else if (modus==1) {
	if (c==dq && !backslash) modus=0
	if (c=="\\") backslash=(1-backslash); else backslash=0
      } else if (modus==2) {
	if (c=="'" && !backslash) modus=0
	if (c=="\\") backslash=(1-backslash); else backslash=0
      } else if (modus==3) {
	if (c=="`") {modus=5; quote=0} else {
	  modus=4
	  if (c=="\\") backslash=1; else baskslash=0
	}
      } else if (modus==4) {
	if ((c=="`" || c=="'") && !backslash) modus=0
	if (c=="\\") backslash=(1-backslash); else backslash=0
      } else if (modus==5) {
	if (quote==0 && c=="`" && !backslash) quote=1; else
	if (quote==1 && c=="`") modus=0; else {
          quote=0
	  if (c=="\\") backslash=(1-backslash); else backslash=0
	}
      } else if (modus==6) {
	if (c=="%") {
	  modus=0
	  suppress=1
	}
      }

      if (modus<=5 && !suppress) {out=out c}
      suppress=0

    }
    print out
  }
